"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@babel/core");
function mergePropTypes(objectExpr, propTypes, state) {
    var properties = objectExpr.properties;
    var existingProps = {};
    // Extract existing props so that we don't duplicate
    properties.forEach(function (property) {
        if (core_1.types.isObjectProperty(property) && core_1.types.isIdentifier(property.key)) {
            existingProps[property.key.name] = true;
            // Check for `airbnb-prop-types`
            if (state.options.forbidExtraProps) {
                var namedImports = state.airbnbPropTypes.namedImports;
                if (
                // componentWithName()
                (core_1.types.isCallExpression(property.value) &&
                    core_1.types.isIdentifier(property.value.callee) &&
                    namedImports.includes(property.value.callee.name)) ||
                    // nonNegativeInteger
                    (core_1.types.isIdentifier(property.value) && namedImports.includes(property.value.name))) {
                    state.airbnbPropTypes.count += 1;
                }
            }
        }
    });
    // Add to the beginning of the array so existing/custom prop types aren't overwritten
    propTypes.forEach(function (propType) {
        if (core_1.types.isIdentifier(propType.key) && !existingProps[propType.key.name]) {
            properties.unshift(propType);
        }
    });
}
exports.default = mergePropTypes;
